CREATE OR REPLACE FUNCTION addTable()
RETURNS VOID AS
$BODY$
BEGIN
    IF EXISTS (SELECT 1 
                 FROM information_schema.columns     
                WHERE table_name= 'pdv_cupom_nao_fiscal_cartao_linx_promo' 
              ) THEN
                         
        RAISE NOTICE 'Tabela pdv_cupom_nao_fiscal_cartao_linx_promo ja existe!' ;
        
    ELSE
        
          CREATE TABLE pdv_cupom_nao_fiscal_cartao_linx_promo (
				 cd_emp			integer
				,cd_filial		integer
				,cd_cx			integer
				,cd_ctr			integer
				,cd_cartao_linx_promo NUMERIC
				,dt_venda		DATE
				,cpf_cnpj		VARCHAR(50)
				,identificacao_cartao VARCHAR(30)
				,valor			numeric(14,4)
				,cd_frm_pgto	integer,
				CONSTRAINT pdv_cupom_nao_fiscal_cartao_linx_promo_pkey PRIMARY KEY (cd_emp, cd_filial, cd_ctr) 
				);
		
            
	  
			
        RAISE NOTICE 'Tabela  pdv_cupom_nao_fiscal_cartao_linx_promo criada com sucesso!';
    END IF; 
    
END; 
$BODY$
LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION addTable()  OWNER TO postgres;
SELECT addTable();
DROP FUNCTION addTable();