create or replace function addcolumn()
returns void as
$body$
begin
     if not  exists ( select * 
                     from information_schema.columns     
                    where table_name= 'pdv_vd_linx_promo_pend_estorno_pontos'  
                  ) then
                  
CREATE TABLE public.pdv_vd_linx_promo_pend_estorno_pontos ( 
	cd_emp 			numeric(6) NOT NULL DEFAULT 0, 
	cd_filial		numeric(6) NOT NULL DEFAULT 0, 
	cd_vd 			numeric(9) NOT NULL DEFAULT 0, 
	cd_cx 			numeric(6) NOT NULL DEFAULT 0, 
	dt_vd 			timestamp NOT NULL, 
	qtde_pontos_est numeric(14,4) NOT NULL DEFAULT 0,
	sts_est 		numeric(1) NOT NULL, 
	ds_erro 		varchar(50) NULL, 
	nr_ecf 			numeric(6) NOT NULL DEFAULT 0, 
	cd_tp_cartao_promo numeric NOT NULL, 
 	nr_cartao 		varchar(25) NOT NULL, 
 	dt_pend_estorno timestamp NOT NULL 
);


COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.cd_vd IS 'código da venda';
COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.cd_cx IS 'código do caixa';
COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.dt_vd IS 'data da venda';
COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.qtde_pontos_est IS 'quantidade de pontos a serem estornados';
COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.sts_est IS '0 - Pendente 1 - Estornado junto ao promo 2 - Critica, estorno não efetuado';
COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.ds_erro IS 'Critica de não ter ocorrido o estorno';
COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.nr_ecf IS 'número do cupom';
COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.cd_tp_cartao_promo IS 'tipo número linx promo;';
COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.nr_cartao IS 'número cartão linx promo;';
COMMENT ON COLUMN public.pdv_vd_linx_promo_pend_estorno_pontos.dt_pend_estorno IS 'objetivo da coluna ser data e horário da pendência lançada';

	raise notice 'Tabela pdv_vd_linx_promo_pend_estorno_pontos criada com sucesso !' ;
    else
    
   	 
		raise notice 'Tabela pdv_vd_linx_promo_pend_estorno_pontos ja existe ! ';

    end if; 
    end; 
$body$
language plpgsql volatile
  cost 100;
alter function addcolumn()  owner to postgres;
select addcolumn();
drop function addcolumn(); 
