
create or replace function addcolumn() 
returns void as 
$body$ 
begin 
    if  not exists (select 1 
					  from information_schema.columns 
                     where table_name= 'est_orc_cpl_lote' 
                       and column_name='id_receita') then 
		   
		alter table est_orc_cpl_lote add column id_receita integer not null default(1);
        
		raise notice 'operacao realizada com sucesso.';
    else 
		raise notice 'coluna já existe.'; 
    end if; 
       
end; 

-- fim bloco principal 
$body$ 
language plpgsql volatile 
  cost 100; 
alter function addcolumn() owner to postgres; 
select addcolumn(); 
drop function addcolumn();

CREATE OR REPLACE FUNCTION addindex() 
RETURNS VOID AS 
$BODY$ 
BEGIN 
	IF exists (SELECT * from pg_indexes 
                    WHERE tablename= 'est_orc_cpl_lote' 
                         and INDEXNAME='est_orc_cpl_lote_pkey') THEN 
	ALTER TABLE est_orc_cpl_lote DROP CONSTRAINT est_orc_cpl_lote_pkey;
    END IF;
END;

$BODY$ 
LANGUAGE plpgsql VOLATILE 
  COST 100; 
ALTER FUNCTION addindex() OWNER TO postgres; 
SELECT addindex(); 
DROP FUNCTION addindex();

CREATE OR REPLACE FUNCTION addindex() 
RETURNS VOID AS 
$BODY$ 
BEGIN 
    IF not EXISTS (SELECT * from pg_indexes 
                    WHERE tablename= 'est_orc_cpl_lote' 
                         and INDEXNAME='est_orc_cpl_lote_pkey') THEN 
		ALTER TABLE public.est_orc_cpl_lote
		ADD CONSTRAINT est_orc_cpl_lote_pkey PRIMARY KEY (cd_emp, cd_filial, cd_orc, cd_lote, cd_it,id_receita);
    END IF;
END;
$BODY$ 
LANGUAGE plpgsql VOLATILE 
  COST 100; 
ALTER FUNCTION addindex() OWNER TO postgres; 
SELECT addindex(); 
DROP FUNCTION addindex();