/*
=======================================================================================
'Nível Classificação.: INFORMAÇÃO RESTRITA
'Versão..............: 20220411
'Job.................:  
'Nome................: EST_FIDELIDADE_DOTZ_CONF 
'Objetivo............: 
'Tabelas.............: EST_FIDELIDADE_DOTZ_CONF
'Dt Criação..........: 11/04/2022
'Dt Ult Alteracão....: --
'Criado por..........: --
'Alterado por........: Marcos Barros
'=======================================================================================
FARMAGOI-29117
*/


CREATE OR REPLACE FUNCTION CREATETABLE()
RETURNS VOID AS 
$BODY$ 
BEGIN 

    IF NOT EXISTS (SELECT 1 FROM information_schema.columns WHERE table_name= 'est_fidelidade_dotz_conf') THEN 
		CREATE TABLE EST_FIDELIDADE_DOTZ_CONF (
			CD_EMP int NOT NULL,
			CD_DOTZ int NOT NULL,
			CD_USU int NOT NULL,
			DT_CAD timestamp without time zone,
			DT_ULT_ATU timestamp without time zone,
			DS_USUARIO_DOTZ varchar(50),
			DS_SENHA_DOTZ varchar(50),
			DS_AMBIENTE_DOTZ varchar(50),
			DS_FTP_ENDERECO_DOTZ varchar(50),
			DS_FTP_USUARIO_DOTZ varchar(50),
			DS_FTP_SENHA_DOTZ varchar(50),
			DS_FORNECEDOR_DOTZ varchar(50),
			PRECO_DOTZ numeric(14, 2) NULL DEFAULT 0,
			VALOR_DOTZ numeric(14, 2) NULL DEFAULT 0,
			TIPO_DOTZ_PDV int DEFAULT 0 NOT NULL,
			TIPO_DOTZ_ORC int DEFAULT 0 NOT NULL,
			TIPO_DOTZ_TLV int DEFAULT 0 NOT NULL,
			CONSTRAINT EST_FIDELIDADE_DOTZ_CONF_idx PRIMARY KEY (CD_EMP,CD_DOTZ)
		);
			ALTER TABLE EST_FIDELIDADE_DOTZ_CONF ADD CONSTRAINT EST_FIDELIDADE_DOTZ_CONF_fk FOREIGN KEY (CD_USU) REFERENCES GLB_USU(CD_USU);

	ELSE    
		RAISE NOTICE 'A TABELA JÁ EXISTE';
	END IF;


END; 
-- FIM BLOCO PRINCIPAL 
$BODY$ 
LANGUAGE PLPGSQL VOLATILE 
  COST 100; 
ALTER FUNCTION CREATETABLE() OWNER TO POSTGRES;
SELECT CREATETABLE(); 
DROP FUNCTION CREATETABLE();