CREATE OR REPLACE FUNCTION ADDCOLUMN()
RETURNS VOID AS
$BODY$
BEGIN
    IF EXISTS (SELECT 1 
                FROM information_schema.columns     
                WHERE table_name = 'pdv_campanha_adicionais' 
                  and column_name='flag_usa_produtos_promo_por_qtde'
	) THEN
           RAISE NOTICE 'Coluna flag_usa_produtos_promo_por_qtde na tabela pdv_campanha_adicionais ja existe!' ;
    ELSE
		ALTER TABLE public.pdv_campanha_adicionais ADD flag_usa_produtos_promo_por_qtde int not null default 0;
        RAISE NOTICE 'Coluna "flag_usa_produtos_promo_por_qtde" criada com sucesso!';
    END IF; 
    
END; 


$BODY$
LANGUAGE PLPGSQL VOLATILE  COST 100;
ALTER FUNCTION ADDCOLUMN()  OWNER TO POSTGRES;
SELECT ADDCOLUMN();
DROP FUNCTION ADDCOLUMN();
